#ifndef TP_INTERP_H
#define TP_INTERP_H

#include "parse.h"
#include "clause.h"
#include "formula.h"

/* INTRODUCTION
*/

/* Public definitions */

typedef struct interp *Interp;

/* End of public definitions */

/* Public function prototypes from interp.c */

void fprint_interp_mem(FILE *fp, BOOL heading);

void p_interp_mem();

Interp compile_interp(Term t);

void transpose_binary(Term t);

void zap_interp(Interp p);

void fprint_interp(FILE *fp, Interp p);

void p_interp(Interp p);

BOOL eval_clause(Clause c, Interp p);

BOOL eval_formula(Formula f, Interp p);

void fprint_interp_from_term(FILE *fp, Term t);

void fprint_interp_from_term2(FILE *fp, Term t);

void fprint_interp_tabular(FILE *fp, Term t);

#endif  /* conditional compilation of whole file */
