#ifndef TP_JUST_H
#define TP_JUST_H

#include "hash.h"
#include "clauseid.h"

/* INTRODUCTION
This package handles clause justifications, that is, lists
that tell how a clause was derived.
<P>
(The justifications for some resolutions are constructed in clash().)
*/

/* Public definitions */

typedef enum {
  BINARY_RES_JUST, HYPER_RES_JUST, UR_RES_JUST, PARA_JUST,
  PARA_FX_JUST, PARA_IX_JUST, PARA_FX_IX_JUST, DEMOD_JUST,
  FACTOR_JUST, MERGE_JUST, FLIP_JUST, BACK_DEMOD_JUST, CD_JUST } Just;

/* End of public definitions */

/* Public function prototypes from just.c */

void fprint_just(FILE *fp, Glist just);

Glist factor_just(Clause c, int literal_num);

Glist cd_just(Clause major, Clause minor);

Glist back_demod_just(Clause c);

Glist binary_res_just(Clause c1, int n1, Clause c2, int n2);

Glist para_just(int rule,
		Clause from, Glist from_vec,
		Clause into, Glist into_vec);

void zap_just(Glist just);

Glist get_clause_ancestors(Clause c);

Glist demod_just(Glist g);

#endif  /* conditional compilation of whole file */
