#include "header.h"

static void reverse_chars(char *s, int start, int end)
{
  if (start < end) {
    char c = s[start]; s[start] = s[end]; s[end] = c;
    reverse_chars(s, start+1, end-1);
  }
}  /* reverse_chars */

static void itoa(int n, char *s)
{
  int i = 0;
  BOOL sign = (n >= 0);
  n = abs(n);
  if (n == 0)
    s[i++] = '0';
  else {
    while (n > 0) {
      s[i++] = '0' + (n % 10);
      n = n / 10;
    }
    if (!sign)
      s[i++] = '-';
  }
  reverse_chars(s, 0, i-1);
  s[i] = '\0';
}  /* itoa */

int main(int argc, char **argv)
{
  char s[100];
  int i;

  for (i = -15; i < 110; i++) {
    itoa(i, s);
    printf("|%d|%s|\n", i, s);
  }
}  /* main */
